clear
squeezerm
w = 2*pi*logspace(0,6);     %range for plots
z = 2*pi*logspace(-1,4); %10kHz range for plots
y = 2*pi*logspace(2,8);


%%%%loop 0

loop0_io(1)= linio('squeezerm/Sum8', 1, 'outin', 'on');
%loop0_io(3)= linio('squeezerm/Sum4', 1, 'none', 'on');
loop0_io(2)= linio('squeezerm/Sum9', 1, 'none', 'on');
loop0_lin = linearize('squeezerm',loop0_io);

loop0t_io(1)= linio('squeezerm/Sum8', 1, 'outin', 'on');
loop0t_lin = linearize('squeezerm',loop0t_io);

loop0pzt_io(1)= linio('squeezerm/Sum8', 1, 'outin', 'on');
loop0pzt_io(2)= linio('squeezerm/G02', 1, 'none', 'on');
loop0pzt_lin= linearize('squeezerm', loop0pzt_io);

loop0pc_io(1)= linio('squeezerm/Sum8', 1, 'outin', 'on');
loop0pc_io(2)= linio('squeezerm/A01', 1, 'none', 'on');
loop0pc_lin= linearize('squeezerm', loop0pc_io);
 
ratioS0=loop0pzt_lin/loop0pc_lin;

loop0cl_io(1)= linio('squeezerm/Sum8', 1, 'outin');
%loop0cl_io(2)= linio('squeezerm/Sum4', 1, 'none', 'on');
%loop0cl_io(3)= linio('squeezerm/Sum9', 1, 'none', 'on');
loop0cl_lin = linearize('squeezerm',loop0cl_io);

figure

bode(loop0_lin, loop0t_lin, w);     %loop0pzt_lin, loop0pc_lin, ratioS0,
title('loop0 open loop')
legend('open loops2 and 3', 'closed 2 and 3')%, 'EOM', 'crossover')
% % 
% % figure
% % pzmap(loop0cl_lin)
% 
%loop 1

loop1_io(1)= linio('squeezerm/Sum25', 1, 'outin', 'on');
loop1_io(2)= linio('squeezerm/Sum4', 1, 'none', 'on');
%loop1_io(3)= linio('squeezerm/Sum9', 1, 'none', 'on');
loop1_lin = linearize('squeezerm',loop1_io);

loop1t_io(1)= linio('squeezerm/Sum25', 1, 'outin', 'on');
loop1t_lin = linearize('squeezerm',loop1t_io);

% loop0pzt_io(1)= linio('squeezerm/Sum8', 1, 'outin', 'on')
% loop0pzt_io(2)= linio('squeezerm/A02', 1, 'none', 'on')
% loop0pzt_lin= linearize('squeezerm', loop0pzt_io)
% 
% loop0pc_io(1)= linio('squeezerm/Sum8', 1, 'outin', 'on');
% loop0pc_io(2)= linio('squeezerm/A01', 1, 'none', 'on');
% loop0pc_lin= linearize('squeezerm', loop0pc_io);
% 
% ratioS0=loop0pzt_lin/loop0pc_lin;

loop1cl_io(1)= linio('squeezerm/Sum25', 1, 'outin');
%loop1cl_io(2)= linio('squeezerm/Sum4', 1, 'none', 'on');
%loop1cl_io(3)= linio('squeezerm/Sum9', 1, 'none', 'on');
loop1cl_lin = linearize('squeezerm',loop1cl_io);

figure

bode(loop1_lin, loop1t_lin, w);     %loop0pzt_lin, loop0pc_lin, ratioS0,
title('loop1')
legend('open loop 2 and 3', 'closed 2 and 3')%, 'EOM', 'crossover')
% 
% % figure
% % pzmap(loop1cl_lin)
% 
% 
% loop1ol_io(1)= linio('squeezerm/S1', 1, 'outin', 'on');
% loop1ol_io(2)= linio('squeezerm/Sum4', 1, 'none', 'on');
% loop1ol_io(3)= linio('squeezerm/Sum9', 1, 'none', 'on');
% loop1ol_lin = linearize('squeezerm',loop1ol_io);
% 
% loop0ol_io(1)= linio('squeezerm/S0', 1, 'outin', 'on');
% loop0ol_io(2)= linio('squeezerm/Sum9', 1, 'none','on');
% loop0ol_lin = linearize('squeezerm',loop0ol_io);
% 
% figure
% bode(loop0cl_lin, loop1cl_lin, w)
% legend('Loop 0 closed loop', 'loop1 closed loop')
% 
% figure
% bode(loop0ol_lin, loop1ol_lin,w)
% legend('loop 0 open loop', 'loop1')
% 
% 

%loop 2

Loop2OL_io(1)= linio('squeezerm/Sum4', 1, 'outin', 'on'); %output-input and open loop just before S2
Loop2OL_io(2)= linio('squeezerm/Sum9',1,'none','on');  %open loop for loop3
Loop2OL_lin = linearize('squeezerm', Loop2OL_io);

%PztS2_io(3)= linio('squeezerm/Sum9',1,'none','on');  %open loop for loop3
PztS2_io(1) = linio('squeezerm/Sum4',1,'in', 'on');  
PztS2_io(2)=linio('squeezerm/A21',1, 'out');        %out right before PZT summation
PztS2_lin=linearize('squeezerm',PztS2_io);

%AddoffS2_io(3)= linio('squeezerm/Sum9',1,'none','on');  %open loop for loop3
AddoffS2_io(1) = linio('squeezerm/Sum4',1,'in','on');  %open loop in loop2
AddoffS2_io(2)=linio('squeezerm/Sum15',1, 'out');        %out phase of Faux before PZT summation
AddoffS2_lin=linearize('squeezerm',AddoffS2_io);

ratioS2 = PztS2_lin/AddoffS2_lin;              %cross over transfer function       

figure
bode(ratioS2, z)
title('Loop 2 Crossover')


figure
bode(Loop2OL_lin, 'r', PztS2_lin,'b', AddoffS2_lin,'g', w)
legend('Open Loop TF for Loop 2', 'PZT compensation', 'additive offset compensation')                %plot of loop2 OL gain
title('open loop for loop2')
% % 
% Loop2CL_io(1)= linio('squeezerm/Sum4', 1, 'inout', 'off'); %input-output just before S2
% %Loop2CL_io(2)= linio('squeezerm/Sum9',1,'none','on');  %open loop for loop3
% Loop2CL_lin = linearize('squeezerm', Loop2CL_io);
% 
% % figure                                           %plot of loop 2 CL gain
% % pzmap(Loop2CL_lin)
% % title('Loop 2 closed loop')
% 
%%%%%Loop 3

Loop3OL_io(1)= linio('squeezerm/Sum9',1,'outin', 'on'); %output, open loop, input before S3
Loop3OL_io(2)=linio('squeezerm/Sum4',1,'none', 'on');  %open loop 2
%Loop3OL_io(2)=linio('squeezerm/Sum12',1, 'out','off');
Loop3OL_lin = linearize('squeezerm', Loop3OL_io);

Loop3CL_io(1)= linio('squeezerm/Sum9',1,'outin', 'off'); %output, open loop, input before S3
%Loop3CL_io(2)=linio('squeezerm/Sum4',1,'none', 'on');  %open loop 2
Loop3CL_lin = linearize('squeezerm', Loop3CL_io);

PZTS3_io(1)= linio('squeezerm/Sum9',1,'in', 'on'); % input before S3, open loop
PZTS3_io(2)= linio('squeezerm/A31', 1, 'out');  %
%PZTS3_io(3)=linio('squeezerm/Sum4',1,'none', 'on');  %open loop 2
PZTS3_lin = linearize('squeezerm', PZTS3_io);

AddoffS3_io(1)= linio('squeezerm/Sum9',1,'in', 'on'); %output, open loop, input before S3
AddoffS3_io(2)= linio('squeezerm/A32', 1, 'out');  %green phase before PZT summation
%AddoffS3_io(3)=linio('squeezerm/Sum4',1,'none', 'on');  %open loop 2
AddoffS3_lin = linearize('squeezerm', AddoffS3_io)/gainS0('parameters');

ratioS3 = PZTS3_lin/AddoffS3_lin;

figure
bode(ratioS3, z)
title('loop3 crossover')


figure
bode(Loop3OL_lin, 'r', PZTS3_lin,'b',PZTS3_lin/2, 'c', AddoffS3_lin,'g', w)
legend('loop3 open loop', 'PZT','PZT/2', 'Additive offset')
title('Loop 3 Open Loop')
% 
% figure 
% pzmap(Loop3CL_lin)
% title('loop 3 CL')
% 
% 
% %check tfs of plants in loops 2 and 3
% pPZTS2_io(4)= linio('squeezerm/Sum9',1,'none', 'on');  %open loop 3
% pPZTS2_io(1)= linio('squeezerm/Sum4',1,'out', 'on'); %output, open loop before S2
% pPZTS2_io(2)= linio('squeezerm/G22', 1, 'none', 'on');  %open additive offset
% pPZTS2_io(3)= linio('squeezerm/A21',1,'in');  % input directly on phase of green
% pPZTS2_lin = linearize('squeezerm', pPZTS2_io);
% 
% pAddoffS2_io(4)= linio('squeezerm/Sum9',1,'none', 'on');  %open loop 3
% pAddoffS2_io(1)= linio('squeezerm/Sum4',1,'out', 'on'); %output, open loop before S2
% pAddoffS2_io(2)= linio('squeezerm/G31', 1, 'none', 'on');  %open PZT
% pAddoffS2_io(3)= linio('squeezerm/A32',1,'in');  %input to additive offset
% pAddoffS2_lin = linearize('squeezerm', pAddoffS2_io);
% 
%  
% %check tfs of plants
% pPZTS3_io(4)= linio('squeezerm/Sum4',1,'none', 'on');  %open loop 2
% pPZTS3_io(1)= linio('squeezerm/Sum9',1,'out', 'on'); %output, open loop before S3
% pPZTS3_io(2)= linio('squeezerm/G32', 1, 'none', 'on');  %open additive offset
% pPZTS3_io(3)= linio('squeezerm/A31',1,'in');  % input directly on phase of green
% pPZTS3_lin = linearize('squeezerm', pPZTS3_io);
% 
% pAddoffS3_io(4)= linio('squeezerm/Sum4',1,'none', 'on');  %open loop 2
% pAddoffS3_io(1)= linio('squeezerm/Sum9',1,'out', 'on'); %output, open loop before S3
% pAddoffS3_io(2)= linio('squeezerm/G31', 1, 'none', 'on');  %open PZT
% pAddoffS3_io(3)= linio('squeezerm/A32',1,'in');  %input to additive offset
% pAddoffS3_lin = linearize('squeezerm', pAddoffS3_io);
% 
% figure
% bode(pPZTS2_lin, pAddoffS2_lin, pPZTS3_lin, pAddoffS3_lin, w)
% title('plant transfer functions')
% legend('2PZT in f aux', '2 additive offset','PZT in green', ' loop3 additive offset')
% % 
% 
% 
% %crosstalk between 2 and 3
% Loop2to3_io(1)= linio('squeezerm/Sum4', 1, 'in');
% %PZT2to3_io(3)= linio('squeezerm/G22', 1, 'none', 'on');  
% Loop2to3_io(2)= linio('squeezerm/Sum9', 1, 'out', 'on');
% Loop2to3_lin = linearize('squeezerm', Loop2to3_io);
% 
% Loop3to2_io(1)= linio('squeezerm/Sum9', 1, 'in');
% Loop3to2_io(2)= linio('squeezerm/Sum4', 1, 'out', 'on');
% Loop3to2_lin = linearize('squeezerm', Loop3to2_io);
% 
% Loop3Addto2_io(1)= linio('squeezerm/Sum9', 1, 'in');
% Loop3Addto2_io(3)= linio('squeezerm/A31', 1, 'none', 'on');  
% Loop3Addto2_io(2)= linio('squeezerm/Sum4', 1, 'out', 'on');
% Loop3Addto2_lin = linearize('squeezerm', Loop3Addto2_io);
% 
% Loop3PZTto2_io(1)= linio('squeezerm/Sum9', 1, 'in');
% Loop3PZTto2_io(3)= linio('squeezerm/A32', 1, 'none', 'on');  
% Loop3PZTto2_io(2)= linio('squeezerm/Sum4', 1, 'out', 'on');
% Loop3PZTto2_lin = linearize('squeezerm', Loop3PZTto2_io);
% 
% figure
% bode(Loop2to3_lin, Loop3to2_lin, w)   
% legend( 'loop2 to 3', 'loop3 to 2', 'loop3 Additive offset to 2', 'loop3 PZT to 2')
% title('transfer functions from one loop to another')

% 
% %transfer functions from phi 0 to..
% 
% phi0topaux_io(1)=linio('squeezerm/phi 0', 1,'in', 'off');
% phi0topaux_io(2)=linio('squeezerm/Sum4',1, 'none', 'on');
% phi0topaux_io(3)=linio('squeezerm/Sum15',1, 'out');
% phi0topaux_io(4)= linio('squeezerm/Sum9', 1, 'none', 'on');
% phi0topaux_lin = linearize('squeezerm', phi0topaux_io);
% 
% phi0topg_io(1)=linio('squeezerm/phi 0', 1,'in', 'off');
% phi0topg_io(2)=linio('squeezerm/Sum4',1, 'none', 'on');
% phi0topg_io(4)= linio('squeezerm/Sum9', 1, 'none', 'on');
% phi0topg_io(3)=linio('squeezerm/Sum12', 1,'out');
% phi0topg_lin = linearize('squeezerm', phi0topg_io);
% 
% phi0tophi2_io(1)=linio('squeezerm/phi 0',1, 'in', 'off');
% phi0tophi2_io(2)=linio('squeezerm/Sum4',1, 'out', 'on');
% phi0tophi2_io(3)= linio('squeezerm/Sum9', 1, 'none', 'on');
% phi0tophi2_lin = linearize('squeezerm', phi0tophi2_io);
% 
% phi0tophi3_io(1)=linio('squeezerm/phi 0',1, 'in', 'off');
% phi0tophi3_io(2)=linio('squeezerm/Sum4',1, 'none', 'on');
% phi0tophi3_io(3)= linio('squeezerm/Sum9', 1, 'out', 'on');
% phi0tophi3_lin = linearize('squeezerm', phi0tophi3_io);
% 
% figure
% bode( phi0topg_lin, phi0tophi2_lin, phi0tophi3_lin, phi0topaux_lin, y)
% legend( 'phi green', 'phi 2', 'phi 3', 'phi0 to phi aux')
% title('phi 0 to')
% 
% %%%%%%%%transfer functions from phi 1 to..
% 
% phi1topaux_io(1)=linio('squeezerm/phi1', 1,'in', 'off');
% phi1topaux_io(2)=linio('squeezerm/Sum4',1, 'none', 'on');
% phi1topaux_io(3)=linio('squeezerm/Sum15',1, 'out');
% phi1topaux_io(4)= linio('squeezerm/Sum9', 1, 'none', 'on');
% phi1topaux_lin = linearize('squeezerm', phi1topaux_io);
% 
% phi1topg_io(1)=linio('squeezerm/phi1', 1,'in', 'off');
% phi1topg_io(2)=linio('squeezerm/Sum4',1, 'none', 'on');
% phi1topg_io(4)= linio('squeezerm/Sum9', 1, 'none', 'on');
% phi1topg_io(3)=linio('squeezerm/Sum12', 1,'out');
% phi1topg_lin = linearize('squeezerm', phi1topg_io);
% 
% phi1tophi2_io(1)=linio('squeezerm/phi1',1, 'in', 'off');
% phi1tophi2_io(2)=linio('squeezerm/Sum4',1, 'out', 'on');
% phi1tophi2_io(3)= linio('squeezerm/Sum9', 1, 'none', 'on');
% phi1tophi2_lin = linearize('squeezerm', phi1tophi2_io);
% 
% phi1tophi3_io(1)=linio('squeezerm/phi1',1, 'in', 'off');
% phi1tophi3_io(2)=linio('squeezerm/Sum4',1, 'none', 'on');
% phi1tophi3_io(3)= linio('squeezerm/Sum9', 1, 'out', 'on');
% phi1tophi3_lin = linearize('squeezerm', phi1tophi3_io);
% 
% figure
% bode( phi1topg_lin, phi1tophi2_lin, phi1tophi3_lin, phi1topaux_lin, y)
% legend( 'phi green', 'phi 2', 'phi 3', 'phi1 to phi aux')
% title('phi 1 to')


% %%%%%%%%%transfer functions from phi 0 to..
% 
% phiL0topaux_io(1)=linio('squeezerm/phiLO', 1,'in', 'off');
% phiL0topaux_io(2)=linio('squeezerm/Sum4',1, 'none', 'off');
% phiL0topaux_io(3)=linio('squeezerm/Sum15',1, 'out');
% phiL0topaux_io(4)= linio('squeezerm/Sum9', 1, 'none', 'off');
% phiL0topaux_lin = linearize('squeezerm', phiL0topaux_io);
% 
% phiL0topg_io(1)=linio('squeezerm/phiLO', 1,'in', 'off');
% phiL0topg_io(2)=linio('squeezerm/Sum4',1, 'none', 'off');
% phiL0topg_io(4)= linio('squeezerm/Sum9', 1, 'none', 'off');
% phiL0topg_io(3)=linio('squeezerm/Sum12', 1,'out');
% phiL0topg_lin = linearize('squeezerm', phiL0topg_io);
% 
% phiL0tophi2_io(1)=linio('squeezerm/phiLO',1, 'in', 'off');
% phiL0tophi2_io(2)=linio('squeezerm/Sum4',1, 'out', 'off');
% phiL0tophi2_io(3)= linio('squeezerm/Sum9', 1, 'none', 'off');
% phiL0tophi2_lin = linearize('squeezerm', phiL0tophi2_io);
% 
% phiL0tophi3_io(1)=linio('squeezerm/phiLO',1, 'in', 'off');
% phiL0tophi3_io(2)=linio('squeezerm/Sum4',1, 'none', 'off');
% phiL0tophi3_io(3)= linio('squeezerm/Sum9', 1, 'out', 'off');
% phiL0tophi3_lin = linearize('squeezerm', phiL0tophi3_io);
% 
% phiL0tophiSQZ_io(1)=linio('squeezerm/phiLO',1, 'in', 'off');
% phiL0tophiSQZ_io(2)=linio('squeezerm/Sum4',1, 'none', 'off');
% phiL0tophiSQZ_io(3)= linio('squeezerm/Sum18', 1, 'out', 'off');
% phiL0tophiSQZ_lin = linearize('squeezerm', phiL0tophiSQZ_io);
% 
% % figure
% % bode( phiL0topg_lin, phiL0tophi2_lin, phiL0tophi3_lin, phiL0topaux_lin, phiL0tophiSQZ_lin, w)
% % legend( 'phi green', 'phi 2', 'phi 3', 'phiL0 to phi aux', 'phiSQZ')
% % title('phi L0 to')
% 
% 
% %%%%%%%%% debugging  transfer functions from phi L0 to..
% phiL0todLSqz_io(1)=linio('squeezerm/phiLO', 1,'in', 'off');
% phiL0todLsqz_io(2)=linio('squeezerm/Sum4',1, 'none', 'off');
% phiL0todLsqz_io(3)=linio('squeezerm/Sum15',1, 'out');
% phiL0todLsqz_io(4)= linio('squeezerm/Sum16', 1, 'none', 'off');
% phiL0todLsqz_lin = linearize('squeezerm', phiL0todLsqz_io);
% 
% phiL0topgsqz_io(1)=linio('squeezerm/phiLO', 1,'in', 'off');
% phiL0topgsqz_io(2)=linio('squeezerm/Sum4',1, 'none', 'off');
% phiL0topgsqz_io(4)= linio('squeezerm/Sum9', 1, 'none', 'off');
% phiL0topgsqz_io(3)=linio('squeezerm/TNL inter ph i fMain', 1,'out');
% phiL0topgsqz_lin = linearize('squeezerm', phiL0topgsqz_io)
% 
% 
% phiL0tophiauxS3_io(1)=linio('squeezerm/phiLO', 1,'in', 'off');
% phiL0tophiauxS3_io(2)=linio('squeezerm/Sum4',1, 'none', 'off');
% phiL0tophiauxS3_io(3)=linio('squeezerm/Sum15',1, 'out');
% phiL0tophiauxS3_io(4)= linio('squeezerm/T OPO NL phi Refl faux1', 1, 'none', 'off');
% phiL0tophiauxS3_lin = linearize('squeezerm', phiL0tophiauxS3_io);
% 
% phiL0toS3_io(1)=linio('squeezerm/phiLO', 1,'in', 'off');
% phiL0toS3_io(2)=linio('squeezerm/Sum4',1, 'none', 'off');
% phiL0toS3_io(4)= linio('squeezerm/Sum9', 1, 'none', 'off');
% phiL0toS3_io(3)=linio('squeezerm/T Phi LO', 1,'out');
% phiL0toS3_lin = linearize('squeezerm', phiL0toS3_io);
% 
% phiL0topgS3_io(1)=linio('squeezerm/phiLO',1, 'in', 'off');
% phiL0topgS3_io(2)=linio('squeezerm/Sum4',1, 'none', 'off');
% phiL0topgS3_io(3)= linio('squeezerm/Sum22', 1, 'out', 'off');
% phiL0topgS3_lin = linearize('squeezerm', phiL0topgS3_io);
% 
% phiL0todLS3_io(1)=linio('squeezerm/phiLO', 1, 'in', 'off');
% phiL0todLS3_io(2)=linio('squeezerm/Sum4',1, 'none', 'off');
% phiL0todLS3_io(3)= linio('squeezerm/Sum23', 1, 'out', 'off');
% phiL0todLS3_lin = linearize('squeezerm', phiL0todLS3_io);
% 
% figure
% bode( phiL0topgS3_lin, phiL0tophiauxS3_lin, phiL0tophi3_lin, phiL0toS3_lin, phiL0todLS3_lin, w)
% legend( 'phi green', 'phi aux S3', 'phi 3 total', 'phiL0 to S3', 'Lopo to S3')
% title('phi L0 to')
% 
% figure
% bode(phiLOtopgsqz_lin, phiLOtodLsqz_lin, phiLOtophisqz_lin, w)
% legend('phase green', 'Lopo', 'total')
% title('phase LO to sqz by..')
% 


%%%%loop 5 ( OPO length)

%Lopocl_io(2)= linio('squeezerm/L OPO', 1, 'in')
Lopocl_io(1)= linio('squeezerm/Sum2', 1, 'outin', 'on');
Lopocl_lin = linearize('squeezerm', Lopocl_io);

Lopocl3_io(1)= linio('squeezerm/Sum2', 1, 'outin', 'on');
%Lopocl3_io(2)= linio('squeezerm/Sum2', 1, 'out');
Lopocl3_io(2)= linio('squeezerm/Sum4', 1, 'none', 'on');
Lopocl3_lin = linearize('squeezerm', Lopocl3_io);


%%%Loop4 SHG length

Lshgol_io(1)= linio('squeezerm/Sum', 1, 'outin', 'on');
%Lshgcl_io(2)= linio('squeezerm/Sum', 1, 'out');
Lshgol_lin = linearize('squeezerm', Lshgol_io);

Lshgcl3_io(1)= linio('squeezerm/Sum', 1, 'outin', 'on');
%Lshgcl3_io(2)= linio('squeezerm/Sum', 1, 'out');
Lshgcl3_io(2)= linio('squeezerm/Sum4', 1, 'none', 'on');
Lshgcl3_lin = linearize('squeezerm', Lshgcl3_io);

figure
bode(Lopocl_lin, Lopocl3_lin, w)
legend('Lopo open loop', 'with 3 open')

figure
bode(Lshgol_lin, Lshgcl3_lin, w)
legend('Lshg open loop', 'with 3 open')



